const noop = () => {}

let wId = 0
global.Page = ({ data, ...rest }) => {
  const page = {
    data,
    setData: jest.fn(function(newData, cb) {
      this.data = {
        ...this.data,
        ...newData
      }

      cb && cb()
    }),
    onLoad: noop,
    onReady: noop,
    onUnLoad: noop,
    __wxWebviewId__: wId++,
    ...rest
  }

  Object.keys(rest).forEach(key => {
    if (typeof rest[key] === 'function') {
      page[key] = rest[key].bind(page)
    }
  })

  global.wxPageInstance = page
  return page
}

const globalData = {
  domain: 'domain',
  dataType: 'dataType',
  systemInfo: {
    platform: 'ios'
  },
  logger: {
    init: jest.fn(),
    log: jest.fn(),
    warn: jest.fn(),
    error: jest.fn(),
    setLogLevel: jest.fn()
  },
  featureSetting: {
    enableAllFeatures: false
  },
  defaultPhotoMode: false
}

global.getApp = function() {
  return {
    globalData,
    isCommonLoaded: () => false
  }
}
global.Date.now = jest.fn(() => 1536708613825)

export function createSelectorQueryMock(mockNodeResponse) {
  return jest.fn(() => ({
    select: jest.fn(() => ({
      node: jest.fn(callback => {
        callback(mockNodeResponse)
        return {
          exec: jest.fn()
        }
      })
    }))
  }))
}

global.wx = {
  showLoading: jest.fn(),
  hideLoading: jest.fn(),
  showModal: jest.fn(),
  request: jest.fn(),
  getStorageSync: jest.fn(),
  showShareMenu: jest.fn(),
  navigateTo: jest.fn(),
  canIUse: jest.fn(),
  getLogManager: jest.fn(() => ({
    debug: jest.fn(),
    info: jest.fn(),
    warn: jest.fn(),
    log: jest.fn()
  })),
  showActionSheet: jest.fn(),
  vibrateShort: jest.fn(),
  getSystemInfoSync: jest.fn(() => ({
    platform: 'ios',
    windowWidth: 300
  })),
  getEnterOptionsSync: jest.fn(() => 1011),
  createSelectorQuery: createSelectorQueryMock(),
  getWindowInfo: jest.fn(() => ({
    pixelRatio: 3
  }))
}
