const logger = require('pfEngine/utils/logger.js')
const debug = require('pfEngine/utils/debug')
const config = require('pfEngine/config.js')

App({
  onLaunch: function(options) {
    this.globalData.systemInfo = wx.getSystemInfoSync()
    this.globalData.logger = logger
    this.globalData.debugSetting.enableEncryption = !!config.config.RSA_PUBLIC_KEY
    logger.init()
    debug.loadSettingFromStorage()
    if (options.query?.debugMode) {
      this.globalData.logger.enableSaveLogToStorage(true)
      this.globalData.logger.setLogLevel(3)
    } else if (options.query?.minitest) {
      this.globalData.logger.setLogLevel(3)
    }
    // AUTO_TEST_START
    this.globalData.autoTestType = options.query?.autoTestType
    // AUTO_TEST_END
  },
  isCommonLoaded() {
    try {
      const commonLib = require('./pfEngine/api/pfCommon')
      return commonLib.getPerfectLib() !== undefined
    } catch (e) {
      return false
    }
  },
  onError(e) {
    logger.error(`Error catch in app.onError`, e)
  },
  globalData: {
    debugSetting: {
      photoMode: false,
      photoUrl: '',
      saveMask: false
    },
    surveyId: null,
    settingId: '3863', // TODO: need to check with PM
    // SDK Parameter
    featureSetting: {
      enableAllFeatures: false
    },
    systemInfo: null,
    defaultPhotoMode: false,
    logger: null,
    domain: null,
    dataType: null,
    handARWebResponse: null,
    // AUTO_TEST_START
    autoTestType: null,
    // AUTO_TEST_END
    backToWebView: false
  }
})
