let compareFunc = null
Component({
  properties: {
    isCompareMode: {
      type: Boolean,
      value: false
    },
    viewHeight: {
      type: Number,
      value: 0
    }
  },
  data: {
    compareX: wx.getSystemInfoSync().windowWidth * (0.5 - 0.05 - 0.1)
  },

  methods: {
    onViewMove(e) {
      if (typeof compareFunc === 'function') {
        const vw = wx.getSystemInfoSync().windowWidth / 100
        compareFunc(e.detail.x / (100 * vw) + 0.15)
      }
    },
    setCompareFunc(passedCompareFunc) {
      if (typeof passedCompareFunc === 'function') compareFunc = passedCompareFunc
      else throw new Error('passingCompareFunc must be a function!')
    }
  }
})
