Component({
  properties: {
    disabled: {
      type: Boolean,
      value: false
    },
    pickerOptions: {
      type: Array,
      value: []
    }, // { type: '', name: '', min: 0, max: 100 }
    values: {
      type: Object,
      value: {}
    } // key: type, value: sliderValue
  },

  data: {
    selected: {
      index: 0,
      type: '',
      value: 0
    }
  },

  observers: {
    values: function() {
      const type = this.data.pickerOptions[this.data.selected.index].type
      this.setData({
        selected: {
          ...this.data.selected,
          type,
          value: this.data.values[type]
        }
      })
    }
  },

  methods: {
    onPickerChange: function(e) {
      const index = e.detail.value
      const type = this.data.pickerOptions[index] && this.data.pickerOptions[index].type
      const selected = {
        index,
        type,
        value: this.data.values[type]
      }
      this.setData({ selected })
    },
    onValueChange: function(e) {
      this.triggerEvent(
        'slidervaluechange',
        {
          type: this.data.selected.type,
          value: e.detail.value
        },
        {}
      )
    },
    onValueChanging: function(e) {
      this.triggerEvent(
        'slidervaluechanging',
        {
          type: this.data.selected.type,
          value: e.detail.value
        },
        {}
      )
    }
  }
})
