const MAKEUP_TYPE = {
  LOOK: {
    type: 'Look',
    name: '主题妆容'
  },
  LIPSTICK: {
    type: 'lipstick',
    name: '唇彩'
  },
  BLUSH: {
    type: 'blush',
    name: '腮红'
  },
  MASCARA: {
    type: 'mascara',
    name: '睫毛膏'
  },
  EYELASHES: {
    type: 'eyelashes',
    name: '假睫毛'
  },
  EYE_SHADOW: {
    type: 'eye_shadow',
    name: '眼影'
  },
  EYE_LINE: {
    type: 'eye_line',
    name: '眼线'
  },
  EYE_CONTACT: {
    type: 'eye_contact',
    name: '隐形眼镜'
  },
  SKIN_TONER: {
    type: 'skin_toner',
    name: '粉底'
  },
  HAIR_DYE: {
    type: 'hair_dye',
    name: '染发'
  },
  EYE_WEAR: {
    type: 'eye_wear',
    name: '眼镜'
  },
  CONTOUR: {
    type: 'contour',
    name: '修容'
  },
  HIGHLIGHT: {
    type: 'highlight',
    name: '高光'
  },
  HIGHLIGHT_AND_CONTOUR: {
    type: 'highlight_contour',
    name: '高光修容'
  },
  BRONZER: {
    type: 'bronzer',
    name: '古铜'
  },
  FACE_ART: {
    type: 'face_art',
    name: '脸部彩绘'
  },
  EARRINGS: {
    type: 'earrings',
    name: '耳环'
  },
  EYE_BROW: {
    type: 'eye_brow',
    name: '眉毛'
  },
  LIP_LINER: {
    type: 'lip_liner',
    name: '唇线'
  },
  CONCEALER: {
    type: 'concealer',
    name: '遮瑕'
  }
}
const OPEN_MODE = {
  NAIL: {
    mode: 'nail',
    types: ['nail', 'NailLook']
  },
  JEWELRY: {
    mode: 'jewelry',
    types: ['watch', 'bracelet', 'ring', 'JewelryLook']
  },
  NECKLACE: {
    mode: 'necklace',
    types: ['necklace']
  }
}
const HANDAR_TYPE = {
  WATCH: {
    type: 'watch',
    name: 'watch'
  },
  BRACELET: {
    type: 'bracelet',
    name: 'bracelet'
  },
  NAIL: {
    type: 'nail',
    name: 'nail'
  },
  RING: {
    type: 'ring',
    name: 'ring'
  },
  NAILLOOK: {
    type: 'NailLook',
    name: 'NailLook'
  },
  JEWELRYLOOK: {
    type: 'JewelryLook',
    name: 'JewelryLook'
  },
  NECKLACE: {
    type: 'necklace',
    name: 'necklace'
  }
}
const SCALE_TYPES = [
  {
    value: 'FIX_XY',
    name: 'FIX XY'
  },
  {
    value: 'CENTER_CROP',
    name: 'CENTER'
  },
  {
    value: 'CENTER_INSIDE',
    name: 'INSIDE'
  }
]
const FEATURE = {
  ZOOM_RATIO: {
    type: 'zoomRatio',
    name: '缩放',
    min: -50,
    max: 50
  },
  SKIN_SMOOTH: {
    type: 'skinSmooth',
    name: '光滑度',
    min: 0,
    max: 100
  },
  FACE_RESHAPE: {
    type: 'faceReshape',
    name: '瘦脸',
    min: -100,
    max: 100
  },
  ENLARGE_EYE: {
    type: 'enlargeEye',
    name: '大眼',
    min: -100,
    max: 100
  }
}
const ALL_MAKEUP_TYPES = Object.values(MAKEUP_TYPE)
const SUPPORT_LIST = [
  MAKEUP_TYPE.LIPSTICK,
  MAKEUP_TYPE.EYE_CONTACT,
  MAKEUP_TYPE.EYE_SHADOW,
  MAKEUP_TYPE.EYE_LINE,
  MAKEUP_TYPE.BLUSH,
  MAKEUP_TYPE.MASCARA,
  MAKEUP_TYPE.EYELASHES,
  MAKEUP_TYPE.SKIN_TONER,
  MAKEUP_TYPE.HAIR_DYE,
  MAKEUP_TYPE.LOOK,
  MAKEUP_TYPE.EYE_WEAR,
  MAKEUP_TYPE.CONTOUR,
  MAKEUP_TYPE.HIGHLIGHT,
  MAKEUP_TYPE.HIGHLIGHT_AND_CONTOUR,
  MAKEUP_TYPE.BRONZER,
  MAKEUP_TYPE.EARRINGS,
  MAKEUP_TYPE.EYE_BROW,
  MAKEUP_TYPE.LIP_LINER,
  MAKEUP_TYPE.CONCEALER
]
const SUPPORT_INTENSITY_LIST = [
  MAKEUP_TYPE.LIPSTICK,
  MAKEUP_TYPE.BLUSH,
  MAKEUP_TYPE.SKIN_TONER,
  MAKEUP_TYPE.EYE_WEAR,
  MAKEUP_TYPE.EYE_BROW,
  MAKEUP_TYPE.BRONZER,
  MAKEUP_TYPE.CONTOUR,
  MAKEUP_TYPE.HIGHLIGHT,
  MAKEUP_TYPE.HIGHLIGHT_AND_CONTOUR,
  FEATURE.SKIN_SMOOTH,
  FEATURE.FACE_RESHAPE,
  FEATURE.ENLARGE_EYE,
  MAKEUP_TYPE.LIP_LINER,
  MAKEUP_TYPE.CONCEALER
]

const SUPPORT_BASIC_FEATURE_LIST = [FEATURE.SKIN_SMOOTH, FEATURE.ZOOM_RATIO]
const SUPPORT_MAKEUP_FEATURE_LIST = [FEATURE.FACE_RESHAPE, FEATURE.ENLARGE_EYE]
const SUPPORT_LANGUAGE_LIST = ['zh_TW', 'zh_CN', 'en_US']

function initTypesMap(initValue, skuTypeList = SUPPORT_LIST) {
  const types = skuTypeList.map(obj => obj.type)
  const map = {}
  types.forEach(type => (map[type] = initValue))
  return map
}

const PRODUCT_CATEGORY = {
  ACNE_BLEMISH_TREATMENTS: {
    label: '去痘遮瑕',
    skuType: 'Acne & Blemish Treatments'
  },
  BODY_CARE: {
    label: '身体护理',
    skuType: 'Body Care'
  },
  CLEANSERS_TONES: {
    label: '清洁爽肤',
    skuType: 'Cleansers & Toners'
  },
  DAY_CARE: {
    label: '日间保养',
    skuType: 'Day Care'
  },
  EYE_LIPCARE: {
    label: '眼部唇部保养',
    skuType: 'Eye & Lip Care'
  },
  MOISTURIZERS_TREATMENTS: {
    label: '补水保湿',
    skuType: 'Moisturizers Treatments'
  },
  NIGHT_CARE: {
    label: '夜间保养',
    skuType: 'Night Care'
  },
  SKIN_CARE_SET: {
    label: '肌肤护理组合',
    skuType: 'Skin Care Set'
  },
  SUN_CARE: {
    label: '防晒',
    skuType: 'Sun Care'
  },
  TOOLS_ACCESSRIES: {
    label: '护肤配件',
    skuType: 'Tools & Accessories'
  },
  ROUTINE: {
    label: '基础护理',
    skuType: 'Routine'
  }
}

const FACE_ATTRIBUTES = [
  'faceShape',
  'eyeShape',
  'eyeSize',
  'eyeAngle',
  'eyeDistance',
  'eyelid',
  'eyebrowShape',
  'eyebrowThickness',
  'eyebrowDistance',
  'eyebrowShortness',
  'eyebrowThinness',
  'lipShape',
  'noseWidth',
  'noseLength',
  'cheekbones',
  'age',
  'skinTone',
  'eyeColor',
  'lipColor',
  'eyebrowColor',
  'hairColor',
  'gender'
]

const LANDMARK_DEF_INDEX = {
  MKL_LEFT_BROW_1: 0,
  MKL_LEFT_BROW_2: 1,
  MKL_LEFT_BROW_3: 2,
  MKL_LEFT_BROW_4: 3,
  MKL_LEFT_BROW_5: 4,
  MKL_LEFT_EYE_OUTSIDE: 5,
  MKL_LEFT_EYE_TOP: 6,
  MKL_LEFT_EYE_INSIDE_OUT: 7,
  MKL_LEFT_EYE_BOTTOM: 8,
  MKL_LEFT_EYE_INSIDE_IN: 9,
  MKL_LEFT_EYE_CENTER: 10,
  MKL_LEFT_EYE_M1: 11,
  MKL_LEFT_EYE_M2: 12,
  MKL_LEFT_EYE_M3: 13,
  MKL_LEFT_EYE_M4: 14,
  MKL_RIGHT_BROW_1: 15,
  MKL_RIGHT_BROW_2: 16,
  MKL_RIGHT_BROW_3: 17,
  MKL_RIGHT_BROW_4: 18,
  MKL_RIGHT_BROW_5: 19,
  MKL_RIGHT_EYE_INSIDE_OUT: 20,
  MKL_RIGHT_EYE_TOP: 21,
  MKL_RIGHT_EYE_OUTSIDE: 22,
  MKL_RIGHT_EYE_BOTTOM: 23,
  MKL_RIGHT_EYE_INSIDE_IN: 24,
  MKL_RIGHT_EYE_CENTER: 25,
  MKL_RIGHT_EYE_M1: 26,
  MKL_RIGHT_EYE_M2: 27,
  MKL_RIGHT_EYE_M3: 28,
  MKL_RIGHT_EYE_M4: 29,
  MKL_NOSE_RIDGE_1: 30,
  MKL_NOSE_RIDGE_2: 31,
  MKL_NOSE_RIDGE_3: 32,
  MKL_NOSE_TOP: 33,
  MKL_NOSE_BOTTOM_L1: 34,
  MKL_NOSE_BOTTOM: 35,
  MKL_NOSE_BOTTOM_R2: 36,
  MKL_NOSE_LEFT: 37,
  MKL_NOSE_RIGHT: 38,
  MKL_MOUTH_LEFT_OUTER_CORNER: 39,
  MKL_MOUTH_TOP_LIP_TOP_2: 40,
  MKL_MOUTH_TOP_LIP_TOP_3: 41,
  MKL_MOUTH_TOP_LIP_TOP_4: 42,
  MKL_MOUTH_RIGHT_OUTER_CORNER: 43,
  MKL_MOUTH_TOP_LIP_TOP_1: 44,
  MKL_MOUTH_TOP_LIP_TOP_5: 45,
  MKL_MOUTH_TOP_LIP_TOP_M1: 46,
  MKL_MOUTH_TOP_LIP_TOP_M2: 47,
  MKL_MOUTH_TOP_LIP_TOP_M3: 48,
  MKL_MOUTH_TOP_LIP_TOP_M4: 49,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_2: 50,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_1: 51,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_3: 52,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_M1: 53,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_M2: 54,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_M3: 55,
  MKL_MOUTH_BOTTOM_LIP_BOTTOM_M4: 56,
  MKL_MOUTH_LEFT_INNER_CORNER: 57,
  MKL_MOUTH_TOP_LIP_BOTTOM: 58,
  MKL_MOUTH_RIGHT_INNER_CORNER: 59,
  MKL_MOUTH_TOP_LIP_BOTTOM_M1: 60,
  MKL_MOUTH_TOP_LIP_BOTTOM_M2: 61,
  MKL_MOUTH_BOTTOM_LIP_TOP: 62,
  MKL_MOUTH_BOTTOM_LIP_TOP_M1: 63,
  MKL_MOUTH_BOTTOM_LIP_TOP_M2: 64,
  MKL_LEFT_FACE_SHAPE_1: 65,
  MKL_LEFT_FACE_SHAPE_M1: 66,
  MKL_LEFT_FACE_SHAPE_2: 67,
  MKL_LEFT_FACE_SHAPE_M2: 68,
  MKL_LEFT_FACE_SHAPE_3: 69,
  MKL_LEFT_FACE_SHAPE_M3: 70,
  MKL_LEFT_FACE_SHAPE_4: 71,
  MKL_LEFT_FACE_SHAPE_M4: 72,
  MKL_CHIN: 73,
  MKL_RIGHT_FACE_SHAPE_M4: 74,
  MKL_RIGHT_FACE_SHAPE_4: 75,
  MKL_RIGHT_FACE_SHAPE_M3: 76,
  MKL_RIGHT_FACE_SHAPE_3: 77,
  MKL_RIGHT_FACE_SHAPE_M2: 78,
  MKL_RIGHT_FACE_SHAPE_2: 79,
  MKL_RIGHT_FACE_SHAPE_M1: 80,
  MKL_RIGHT_FACE_SHAPE_1: 81,
  MKL_LEFT_BROW_BOTTOM_2: 82,
  MKL_RIGHT_BROW_BOTTOM_2: 83
}

module.exports = {
  ALL_MAKEUP_TYPES,
  SUPPORT_LIST,
  SUPPORT_INTENSITY_LIST,
  FEATURE,
  SUPPORT_BASIC_FEATURE_LIST,
  SUPPORT_MAKEUP_FEATURE_LIST,
  SUPPORT_LANGUAGE_LIST,
  SCALE_TYPES,
  initTypesMap,
  MAKEUP_TYPE,
  OPEN_MODE,
  HANDAR_TYPE,
  PRODUCT_CATEGORY,
  FACE_ATTRIBUTES,
  LANDMARK_DEF_INDEX
}
