const app = getApp()
const util = require('../../../pfEngine/utils/util.js')

let secretTouched = 0
let secretTimeout = null
let platform
Page({
  data: {
    disableActionBtn: false,
    warningText: '',
    domain: app.globalData.domain,
    dataType: app.globalData.dataType
  },
  onLoad: function(options) {
    platform = app.globalData.systemInfo.platform
    if (platform === 'devtools') {
      this.setData({
        disableActionBtn: true,
        warningText: '点击预览按钮，通过微信的扫一扫在手机上体验小程序'
      })
    }
    this.handleConfigDomain(options)
  },
  onShow: function() {
    this.displayDomainAndDataType()
  },
  handleConfigDomain: function(options) {
    if (options.source === 'qrCode') {
      util.setAppParam(options, true)
    }
    const config = util.getAppParam()
    app.globalData.domain = config.domain ? config.domain : app.globalData.domain
    app.globalData.dataType = config.dataType ? config.dataType : app.globalData.dataType
    this.displayDomainAndDataType()
  },

  onHide: function() {
    this.removeSecretTimeout()
  },

  openCameraPage: function(e) {
    if (this.data.disableActionBtn) return
    const cameraPage = '/pages/handAR/index/index'
    wx.navigateTo({
      url: app.isCommonLoaded()
        ? cameraPage
        : `/pfEngine/loadCommon/loadpkg?cameraPage=${cameraPage}`
    })
  },

  onSecretStart(e) {
    secretTouched += 1
    if (secretTouched === 2 && !secretTimeout) {
      wx.vibrateShort()
      secretTimeout = setTimeout(() => {
        secretTouched = 0
        secretTimeout = null
        wx.showActionSheet({
          itemList: ['祕技頁'],
          success: result => {
            switch (result.tapIndex) {
              case 0:
                wx.navigateTo({
                  url: '/pages/handAR/secretPage/secretPage'
                })
                break
            }
          }
        })
      }, 3000)
    }
  },

  displayDomainAndDataType() {
    this.setData({
      domain: app.globalData.domain,
      dataType: app.globalData.dataType
    })
  },

  onSecretEnd(e) {
    secretTouched = 0
    this.removeSecretTimeout()
  },

  removeSecretTimeout() {
    if (secretTimeout) {
      clearTimeout(secretTimeout)
      secretTimeout = null
    }
  }
})
