import logger from '../../pfEngine/utils/logger'
const app = getApp()
const util = require('../../pfEngine/utils/util.js')
let secretTouched = 0
let secretTimeout = null
Page({
  data: {
    disableActionBtn: false,
    warningText: '',
    domain: app.globalData.domain,
    dataType: app.globalData.dataType,
    enableFunction: {
      HandAR: true
    },
    showPrivacyBtn: false
  },
  onLoad: function(options) {
    app.globalData.systemInfo = wx.getSystemInfoSync()
    if (app.globalData.systemInfo.platform === 'devtools') {
      this.setData({
        disableActionBtn: true,
        warningText: '点击预览按钮，通过微信的扫一扫在手机上体验小程序'
      })
    }
    this.handleConfigDomain(options)
    // this.checkFunctionsEnabled()
    if (wx.onNeedPrivacyAuthorization) {
      wx.onNeedPrivacyAuthorization(resolve => {
        this.setData({
          showPrivacyBtn: true
        })
        this.resolvePrivacyAuthorization = resolve
      })
      wx.requirePrivacyAuthorize()
    }
  },
  onShow: function() {
    this.displayDomainAndDataType()
  },
  handleAgreePrivacyAuthorization() {
    this.setData({
      showPrivacyBtn: false
    })
    this?.resolvePrivacyAuthorization?.({ buttonId: 'agree-btn', event: 'agree' })
  },
  handleConfigDomain: function(options) {
    if (options.source === 'qrCode') {
      util.setAppParam(options, true)
    }
    const config = util.getAppParam()
    app.globalData.domain = config.domain ? config.domain : app.globalData.domain
    app.globalData.dataType = config.dataType ? config.dataType : app.globalData.dataType
    this.displayDomainAndDataType()
  },

  onUnload: () => {
    
  },
  onHide: function() {
    this.removeSecretTimeout()
  },

  openPage: function(e) {
    const pageName = e.target.id
    wx.navigateTo({
      url: `/pages/${pageName}/entry/entry`
    })
  },

  onSecretStart(e) {
    secretTouched += 1
    if (secretTouched === 2 && !secretTimeout) {
      wx.vibrateShort()
      secretTimeout = setTimeout(() => {
        secretTouched = 0
        secretTimeout = null
        wx.showActionSheet({
          itemList: ['Logcat', 'PF祕技頁'],
          success: result => {
            switch (result.tapIndex) {
              case 0:
                wx.navigateTo({
                  url: '/pages/logPage/logPage'
                })
                break
              case 1:
                wx.navigateTo({
                  url: '/pages/secretPage/secretPage'
                })
                break
            }
          }
        })
      }, 3000)
    }
  },
  displayDomainAndDataType() {
    this.setData({
      domain: app.globalData.domain,
      dataType: app.globalData.dataType
    })
  },
  onSecretEnd(e) {
    secretTouched = 0
    this.removeSecretTimeout()
  },

  removeSecretTimeout() {
    if (secretTimeout) {
      clearTimeout(secretTimeout)
      secretTimeout = null
    }
  },

  checkFunctionsEnabled() {
    
  },

  openPrivacyContract() {
    wx.openPrivacyContract()
  },

  disagreePrivacy() {
    this.setData({
      showPrivacyBtn: false
    })
  }
})
