const projectPath = require('./getProjectPath')
const execSync = require('child_process').execSync

let currentFile = ''
let currentMapFileMap = ''
const fileErrorsMap = {}
const authorCountMap = {}
try {
  execSync('eslint {pages,pfEngine}', { cwd: projectPath })
} catch (e) {
  const rawStdout = e.stdout.toString()
  const stdout = rawStdout.slice(0, rawStdout.indexOf('✖'))
  stdout.split('\n').forEach((line, i) => {
    const trimmedLine = line
      .trim()
      .split(' ')
      .filter(string => string !== '')
      .join(' ')
    if (trimmedLine.includes(projectPath) && currentFile !== trimmedLine) {
      currentFile = trimmedLine
      currentMapFileMap = currentFile.replace(`${projectPath}/`, '')
      fileErrorsMap[currentMapFileMap] = []
    } else if (currentFile) {
      const errorLine = parseInt(trimmedLine.split(':')[0])
      if (Number.isNaN(errorLine)) return
      const blameName = execSync(`git blame ${currentFile} -f -L ${errorLine},${errorLine}`, {
        cwd: projectPath
      })
        .toString()
        .split(' ')[2]
        .slice(1)
      fileErrorsMap[currentMapFileMap].push(`${blameName.trim()} ${trimmedLine}`)
      if (!authorCountMap[blameName]) authorCountMap[blameName] = 1
      else authorCountMap[blameName]++
    }
  })
  const outputString = Object.keys(authorCountMap).reduce((acc, currKey, currIndex) => {
    return (
      acc +
      ` ${currKey}: ${authorCountMap[currKey]}${
        currIndex === Object.keys(authorCountMap).length - 1 ? '' : ','
      }`
    )
  }, 'Errors found,')
  console.log(outputString)
}
