const platform = wx.getSystemInfoSync().platform
class PfCommon {
  plugin
  perfectLib
  tf
  backendName = null
  getPerfectLib = () => {
    if (this.perfectLib) {
      return this.perfectLib
    } else {
      throw new Error('Common lib is not found.')
    }
  }

  init = (args, callback) => {
    this.plugin = args.plugin
    this.perfectLib = args.perfectLib
    this.tf = args.tf
    this.getPerfectLib().init(
      {
        ...args
      },
      callback
    )
  }

  configTfPlugin = () => {
    if (platform === 'ios' && !this.backendName) {
      if (this.plugin && this.tf) {
        try {
          this.backendName = Date.now()
          this.plugin.configPlugin({
            tf: this.tf,
            backendName: this.backendName,
            canvas: wx.createOffscreenCanvas()
          })
        } catch (e) {
          console.error('configPlugin error', e)
        }
      }
    }
  }

  clearTfPlugin = () => {
    if (platform === 'ios') {
      if (this.tf) {
        this.tf.removeBackend(this.backendName)
        this.backendName = null
      } else {
        throw new Error('tf lib is not found.')
      }
    }
  }
}

const commonInstance = new PfCommon()

module.exports = {
  init: commonInstance.init,
  configTfPlugin: commonInstance.configTfPlugin,
  clearTfPlugin: commonInstance.clearTfPlugin,
  getPerfectLib: commonInstance.getPerfectLib
}
