class pfHandAR {
  handAR

  _getHandAR = () => {
    if (this.handAR) {
      return this.handAR
    } else {
      throw new Error('HandLib not found.')
    }
  }

  init = async args => {
    this.handAR = await require.async('../loadModule/HandAR')
    const commonLib = await require.async('./pfCommon')
    return this._getHandAR().init({
      perfectLib: commonLib.getPerfectLib(),
      ...args
    })
  }

  unInit = callback => {
    this._getHandAR().unInit(callback)
    this.handAR = null
  }

  getListByEffect = (type, start = 0, orderedProducts) =>
    this._getHandAR().getListByEffect(type, start, orderedProducts)

  getSkuSetListByEffect = (type, start = 0) => this._getHandAR().getSkuSetListByEffect(type, start)

  getLooks = type => this._getHandAR().getLooks(type)

  getNailLooks = () => this._getHandAR().getNailLooks()

  getWebTryOnUrl = (products, initGuid, openMode, options) => {
    return this._getHandAR().getWebTryOnUrl(products, initGuid, openMode, options)
  }
}

// eslint-disable-next-line new-cap
const handInstance = new pfHandAR()

module.exports = {
  init: handInstance.init,
  unInit: handInstance.unInit,
  getListByEffect: handInstance.getListByEffect,
  getSkuSetListByEffect: handInstance.getSkuSetListByEffect,
  getLooks: handInstance.getLooks,
  getNailLooks: handInstance.getNailLooks,
  getWebTryOnUrl: handInstance.getWebTryOnUrl
}
