import { getProductMappingList } from '../utils/debug'
import status from '../utils/status.js'

const app = getApp()
Page({
  onLoad: async function(options) {
    const util = require('../utils/util')
    const appParam = util.getAppParam()
    const commonLib = require('../api/pfCommon.js')
    const config = require('../config.js')
    const debug = require('../utils/debug')
    commonLib.init(
      {
        perfectLib: require('./PerfectLib'),
        config: config.config,
        logger: getApp().globalData.logger,
        productMappingList: getProductMappingList(),
        domain: appParam.domain,
        dataType: appParam.dataType,
        skincareServer: appParam.skincareServer,
        debug,
        debugSDKSetting: debug.getSDKSetting()
      },
      statusCode => {
        if (statusCode !== status.STATUS_SUCCESS) {
          wx.showToast({
            title: '认证失败',
            duration: 3000
          })
        }
        commonLib.configTfPlugin()
        wx.redirectTo({
          url: options.cameraPage
        })
      }
    )
  }
})
