import { setValue, getValue } from './util'

const PermissionUtil = {
  requirePermission(args, callback) {
    const key = args.key
    const scope = args.scope
    PermissionUtil._permissionCheck(scope).then(isPass => {
      if (isPass) {
        callback()
      } else {
        // check ever required this permission
        if (!getValue(key) || getValue(key) === '' || getValue(key) === false) {
          PermissionUtil._auth(scope, callback).then(() => {
            setValue(key, true)
          })
        } else {
          wx.openSetting()
        }
      }
    })
  },

  _auth(scope, callback) {
    return new Promise((resolve, reject) => {
      wx.authorize({
        scope,
        success: res => {
          callback()
        },
        complete: () => {
          resolve()
        }
      })
    })
  },

  _permissionCheck(scope) {
    return new Promise((resolve, reject) => {
      wx.getSetting({
        success: res => {
          resolve(!!res.authSetting[scope])
        },
        fail: () => {
          resolve(false)
        }
      })
    })
  }
}

export default PermissionUtil
